#include <immintrin.h>
#include <stdio.h>

void multiply8_v1(float * A, float *x);
void multiply8_v2(float * A, float *x);



int main(int argc, char** argv)
{

   float A[32], x[8];

   
   /**************************************
    * Initialize 
    **************************************/
   for(int i=0;i < 8; ++i)
      x[i] = i+1;

   for(int i=0;i < 8; ++i){
      for(int j=0;j < 4; ++j){
         A[i*4 + j] = j + i*10;
      }
   }

   /**************************************
    * print before 
    **************************************/
   printf("Before:\n");
   for(int j=0;j < 4; ++j){
      for(int i=0;i < 8; ++i){
         printf("%f ",A[i * 4 + j]);
      }
      printf("\n");
   }

   multiply8_v1(A, x);

   /**************************************
    * print after 
    **************************************/
   printf("\nAfter:\n");
   for(int j=0;j < 4; ++j){
      for(int i=0;i < 8; ++i){
         printf("%f ",A[i * 4 + j]);
      }
      printf("\n");
   }
}


void multiply8_v1(float * A, float *x)
{
   /**************************************
    * Load Data into vec registers
    **************************************/
   __m128 A_xmm[8]; 
   __m256 x_ymm = _mm256_loadu_ps (x);

   for(int i=0;i < 8; ++i){
      A_xmm[i] = _mm_loadu_ps(A+i*4);
   }

   /**************************************
    * Multiply 
    **************************************/
   __m128 tmp = _mm256_extractf128_ps(x_ymm, 0);
   A_xmm[0] = _mm_mul_ps( A_xmm[0], _mm_shuffle_ps(tmp,tmp,0));
   A_xmm[1] = _mm_mul_ps( A_xmm[1], _mm_shuffle_ps(tmp,tmp,0x55));
   A_xmm[2] = _mm_mul_ps( A_xmm[2], _mm_shuffle_ps(tmp,tmp,0xAA));
   A_xmm[3] = _mm_mul_ps( A_xmm[3], _mm_shuffle_ps(tmp,tmp,0xFF));

   tmp = _mm256_extractf128_ps(x_ymm, 1);
   A_xmm[4] = _mm_mul_ps( A_xmm[4], _mm_shuffle_ps(tmp,tmp,0));
   A_xmm[5] = _mm_mul_ps( A_xmm[5], _mm_shuffle_ps(tmp,tmp,0x55));
   A_xmm[6] = _mm_mul_ps( A_xmm[6], _mm_shuffle_ps(tmp,tmp,0xAA));
   A_xmm[7] = _mm_mul_ps( A_xmm[7], _mm_shuffle_ps(tmp,tmp,0xFF));



   /**************************************
    * Store Data
    **************************************/
   for(int i=0;i < 8; ++i){
      _mm_storeu_ps(A+i*4, A_xmm[i]);
   }
}




void multiply8_v1_alt(float * A, float *x)
{
   /**************************************
    * Load Data into vec registers
    **************************************/
   __m128 A_xmm[8]; 
   __m256 x_ymm = _mm256_loadu_ps (x);

   for(int i=0;i < 8; ++i){
      A_xmm[i] = _mm_loadu_ps(A+i*4);
   }

   /**************************************
    * Multiply 
    **************************************/
   __m128 tmp = _mm256_castps256_ps128(x_ymm);
   A_xmm[0] = _mm_mul_ps( A_xmm[0], _mm_permute_ps(tmp,0));
   A_xmm[1] = _mm_mul_ps( A_xmm[1], _mm_permute_ps(tmp,0x55));
   A_xmm[2] = _mm_mul_ps( A_xmm[2], _mm_permute_ps(tmp,0xAA));
   A_xmm[3] = _mm_mul_ps( A_xmm[3], _mm_permute_ps(tmp,0xFF));

   tmp = _mm256_extractf128_ps(x_ymm, 1);
   A_xmm[4] = _mm_mul_ps( A_xmm[4], _mm_permute_ps(tmp,0));
   A_xmm[5] = _mm_mul_ps( A_xmm[5], _mm_permute_ps(tmp,0x55));
   A_xmm[6] = _mm_mul_ps( A_xmm[6], _mm_permute_ps(tmp,0xAA));
   A_xmm[7] = _mm_mul_ps( A_xmm[7], _mm_permute_ps(tmp,0xFF));



   /**************************************
    * Store Data
    **************************************/
   for(int i=0;i < 8; ++i){
      _mm_storeu_ps(A+i*4, A_xmm[i]);
   }
}
